-- $Horde: wicked/scripts/sql/wicked.sql,v 1.2 2004/09/21 03:34:05 chuck Exp $

CREATE TABLE wicked_pages (
    page_name VARCHAR(100) NOT NULL,
    page_text TEXT,
    page_hits INT DEFAULT 0,
    page_locked SMALLINT NOT NULL DEFAULT 0,
    page_majorversion SMALLINT,
    page_minorversion INT,
    version_created INT NOT NULL,
    change_author VARCHAR(255),
    change_log TEXT,
--
    PRIMARY KEY (page_name)
);

CREATE TABLE wicked_history (
    page_name VARCHAR(100) NOT NULL,
    page_text TEXT,
    page_majorversion SMALLINT,
    page_minorversion INT,
    version_created INT NOT NULL,
    change_author VARCHAR(255),
    change_log TEXT
);

CREATE INDEX wicked_history_name_idx ON wicked_history (page_name);
CREATE INDEX wicked_history_version_idx ON wicked_history (page_majorversion, page_minorversion);

CREATE TABLE wicked_attachments (
    page_name VARCHAR(100) NOT NULL,
    attachment_name VARCHAR(100) NOT NULL,
    attachment_hits INT DEFAULT 0,
    attachment_majorversion SMALLINT,
    attachment_minorversion INT,
    attachment_created INT NOT NULL,
    change_author VARCHAR(255),
    change_log TEXT,
--
    PRIMARY KEY (page_name, attachment_name)
);

CREATE TABLE wicked_attachment_history (
    page_name VARCHAR(100) NOT NULL,
    attachment_name VARCHAR(100) NOT NULL,
    attachment_majorversion SMALLINT,
    attachment_minorversion INT,
    attachment_created INT NOT NULL,
    change_author VARCHAR(255),
    change_log TEXT
);

CREATE INDEX wicked_attachment_history_name_idx ON wicked_attachment_history (page_name, attachment_name);
CREATE INDEX wicked_attachment_history_version_idx ON wicked_attachment_history (attachment_majorversion, attachment_minorversion);

GRANT SELECT, INSERT, UPDATE, DELETE ON wicked_pages TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON wicked_history TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON wicked_attachments TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON wicked_attachment_history TO horde;
